'use strict';



var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ws = require('ws');

var _ws2 = _interopRequireDefault(_ws);

var _level = require('level');

var _level2 = _interopRequireDefault(_level);

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _queryString = require('query-string');

var _queryString2 = _interopRequireDefault(_queryString);

var _helloEvents = require('hello-events');

var _helloEvents2 = _interopRequireDefault(_helloEvents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HelloWebRTCServer = function (_HelloEvents) {
  _inherits(HelloWebRTCServer, _HelloEvents);

  function HelloWebRTCServer(options, callback) {
    _classCallCheck(this, HelloWebRTCServer);

    var _this = _possibleConstructorReturn(this, (HelloWebRTCServer.__proto__ || Object.getPrototypeOf(HelloWebRTCServer)).call(this));

    _this.server = new _ws2.default.Server(Object.assign({ port: 8686 }, options), callback);
    _this.db = (0, _level2.default)(options.db ? options.db : __dirname + '/hello-webrtc.db');

    _this.connections = [];

    _this.server.on('connection', function (socket, request) {
      function disconnect() {
        _this.connections = _this.connections.filter(function (item) {
          if (item.user === currentUser && item.socket.readyState === 1) {
            item.socket.dispatch(item.signature, 'offline', null);
            item.socket.close();
            return false;
          } else if (item.from === currentUser && item.socket.readyState === 1) {
            item.socket.dispatch(item.signature, 'break', null);
            item.socket.close();
            return false;
          } else if (item.to === currentUser && item.socket.readyState === 1) {
            item.socket.dispatch(item.signature, 'break', null);
            item.socket.close();
            return false;
          }
          return true;
        });
      }

      var urlobjs, query, params, token, currentUser, disconnect;
      return Promise.resolve().then(function () {
        urlobjs = _url2.default.parse(request.url);
        query = urlobjs.query;
        params = _queryString2.default.parse(query);
        token = params.token;


        if (!token) {
          throw new Error('[HelloWebRTC Signaling Server:] token not exists.');
        }

        return _this.get('token:' + token + '.user');
      }).then(function (_resp) {
        currentUser = _resp;


        if (!currentUser) {
          return Promise.resolve().then(function () {
            return _this.getUser(token);
          }).then(function (_resp) {
            currentUser = _resp;
            return _this.set('token:' + token + '.user', currentUser);
          });
        }
      }).then(function () {
        disconnect = disconnect;
        socket.dispatch = function (signature, type, data) {
          if (socket.readyState > 1) {
            disconnect();
            return;
          }
          var message = JSON.stringify({ signature: signature, type: type, data: data });
          socket.send(message);
        };
        socket.subscribe = function (event, callback) {
          socket.on('message', function (message) {
            var _JSON$parse = JSON.parse(message),
                type = _JSON$parse.type,
                data = _JSON$parse.data,
                signature = _JSON$parse.signature;

            _this.debug(JSON.stringify({ user: currentUser, signature: signature, type: type, data: data }, null, 4));
            if (event === type) {
              callback(signature, data);
            }
          });
        };

        socket.subscribe('online', function (signature) {
          var info;

          disconnect();
          info = {
            user: currentUser,
            socket: socket,
            signature: signature
          };

          _this.connections.push(info);
          _this.trigger('online', info);
        });
        socket.subscribe('request', function (signature, _ref) {
          var user = _ref.user,
              room = _ref.room;

          var node2 = _this.connections.find(function (item) {
            return item.user === user;
          });
          if (!node2) {
            var message = 'Not allowed when send request to ' + user + '.';
            socket.dispatch(signature, 'error', { message: message });
            _this.debug(message);
            return;
          }
          node2.socket.dispatch(node2.signature, 'request', { user: currentUser, room: room });
        });
        socket.subscribe('response', function (signature, _ref2) {
          var user = _ref2.user,
              room = _ref2.room;

          var node2 = _this.connections.find(function (item) {
            return item.user === user;
          });
          if (!node2) {
            var message = 'Not allowed when send response to ' + user + '.';
            socket.dispatch(signature, 'error', { message: message });
            _this.debug(message);
            return;
          }
          node2.socket.dispatch(node2.signature, 'response', { user: currentUser, room: room });
        });

        socket.subscribe('create', function (signature, _ref3) {
          var user, room, peer, info;
          user = _ref3.user;
          room = _ref3.room;
          peer = _this.connections.find(function (item) {
            return item.from === currentUser && item.to === user && item.room === room;
          });

          if (peer) {
            peer.socket.dispatch(peer.signature, 'break', null);
            _this.connections = _this.connections.filter(function (item) {
              return item !== node;
            });
          }
          info = {
            from: currentUser,
            to: user,
            room: room,
            signature: signature,
            socket: socket
          };

          _this.connections.push(info);
          _this.trigger('break', info);
        });
        socket.subscribe('icecandidate', function (signature, candidate) {
          var peer, message;
          peer = _this.connections.find(function (item) {
            return item.signature === signature;
          });

          if (!peer) {
            message = 'Not allowed when send icecandidate to ' + user + '.';

            socket.dispatch(signature, 'error', { message: message });
            _this.debug(message);
          } else {
            peer.socket.dispatch(peer.signature, 'icecandidate', candidate);
          }
        });
        socket.subscribe('offer', function (signature, description) {
          var peer, message;
          peer = _this.connections.find(function (item) {
            return item.signature === signature;
          });

          if (!peer) {
            message = 'Not allowed when send offer to ' + user + '.';

            socket.dispatch(signature, 'error', { message: message });
            _this.debug(message);
          } else {
            peer.socket.dispatch(peer.signature, 'offer', description);
          }
        });
        socket.subscribe('answer', function (signature, description) {
          var peer, message;
          peer = _this.connections.find(function (item) {
            return item.signature === signature;
          });

          if (!peer) {
            message = 'Not allowed when send answer to ' + user + '.';

            socket.dispatch(signature, 'error', { message: message });
            _this.debug(message);
          } else {
            peer.socket.dispatch(peer.signature, 'answer', description);
          }
        });
      });
    });
    _this.server.on('error', function (e) {
      _this.debug(e);
    });
    return _this;
  }

  _createClass(HelloWebRTCServer, [{
    key: 'debug',
    value: function debug() {
      var _console;

      var time = new Date();

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      (_console = console).log.apply(_console, ['[' + (time.getHours() + ':' + time.getMinutes() + ':' + time.getSeconds()) + ' HelloWebRTC:]'].concat(args));
    }
  }, {
    key: 'set',
    value: function set(key, value) {
      var expires,
          data,
          input,
          _this10 = this,
          _arguments9 = arguments;

      return Promise.resolve().then(function () {
        expires = _arguments9.length > 2 && _arguments9[2] !== undefined ? _arguments9[2] : 0;
        data = {
          time: Date.now(),
          expires: expires,
          data: value
        };
        input = JSON.stringify(data);
        return _this10.db.put(key, input);
      }).then(function () {});
    }
  }, {
    key: 'get',
    value: function get(key) {
      var data,
          output,
          _this11 = this;

      return Promise.resolve().then(function () {
        return Promise.resolve().then(function () {
          return _this11.db.get(key);
        }).then(function (_resp) {
          data = _resp;

          if (!data) {
            return;
          }
          output = JSON.parse(data);
          return _this11.remove(key);
        }).then(function () {
          if (output.expires && Date.now() > output.time + output.expires) {
            return null;
          }
          return output.data;
        }).catch(function (e) {
          return;
        });
      }).then(function () {});
    }
  }, {
    key: 'remove',
    value: function remove(key) {
      var _this12 = this;

      return Promise.resolve().then(function () {
        return _this12.db.del(key);
      }).then(function () {});
    }
  }, {
    key: 'getUser',
    value: function getUser(token) {
      return Promise.resolve(token);
    }
  }]);

  return HelloWebRTCServer;
}(_helloEvents2.default);

module.exports = HelloWebRTCServer;
